IF COLUMNPROPERTY(object_id('dbo.MEASURE'), 'm_unit', 'AllowsNull') is NULL
   ALTER TABLE dbo.MEASURE ADD m_unit INT NULL
GO


IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[FR_CHECK_S_E]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[FR_CHECK_S_E]

GO
CREATE PROCEDURE [dbo].FR_CHECK_S_E
    @nLink	INT
	,@cMode	varchar(50)
AS

SET NOCOUNT ON

    DECLARE @newnumber VARCHAR(20), @intDepLink INT, @NOW DATETIME, @iYear INT, @iMonth INT, @dDocDate DATETIME, @SHOW_ALL TINYINT, @iCASHIFT_LINK INT
    
    -- 
	SELECT @intDepLink = ISNULL(gp.DEP,UI.DEP_LINK)
	      ,@NOW = UI.WORKDATE
		  ,@SHOW_ALL = CONVERT(TINYINT,UI.SHOW_ALL)
		  ,@dDocDate  = ISNULL(GP.[DATE],UI.WORKDATE)
	FROM dbo.USER_INFO	UI
	LEFT JOIN dbo.G_PROV GP ON GP.LINK = @nLink
	
	--if @nLink<0 OR @cMode = 'copy'
	--	EXEC dbo.X_DOCUMENT_GET_NEXT_NUMBER @cDocCode = 'FR_CHECK', @intDepLink = @intDepLink, @cNextNum = @newnumber OUT
	
	--    
	SELECT @iCASHIFT_LINK = CS.LINK_UP
	FROM dbo.FR_CASHIFT CS 
	INNER JOIN dbo.G_PROV GP ON GP.LINK = CS.LINK_UP AND GP.DEP = @intDepLink
	WHERE CS.STATE1 = 1 AND CS.END_TIME IS NULL
	AND (SELECT COUNT(*) FROM dbo.FR_CASHIFT CS1 
	              INNER JOIN dbo.G_PROV GP1 ON GP1.LINK = CS1.LINK_UP AND GP1.DEP = @intDepLink
	              WHERE CS1.END_TIME IS NULL
					AND (SELECT DATEDIFF ( MINUTE , CS1.BEGIN_TIME , GETDATE() ) /60) < 24) = 1

	;with contact as (select ci.department dep_link, ci.contact phone from dbo.contact_type ct
						inner join dbo.contact_info ci on ct.link = ci.contact_type
						where ct.code = '')
	, contact1 as (select ci.department dep_link, ci.contact email from dbo.contact_type ct
						inner join dbo.contact_info ci on ct.link = ci.contact_type
						where ct.code = 'MAIL')
	SELECT
	    del				= CONVERT(INT,0)          
		,upd			= COALESCE(n.new,c.copy,0)
		,LINK			= CASE WHEN ISNULL(n.new,c.copy) IS NULL THEN g.LINK ELSE -1*(ISNULL(n.new,g.LINK)) END
		,[DATE]			= CASE WHEN ISNULL(n.new,c.copy) IS NULL THEN G.[DATE] ELSE @NOW END
		,DATE_PROV      = CASE WHEN ISNULL(n.new,c.copy) IS NULL THEN g.DATE_PROV ELSE NULL END
		,g.GET_STORE
		,NUMBER			= CASE WHEN ISNULL(n.new,c.copy) IS NULL THEN G.NUMBER ELSE NULL END
		,DEP_LINK		= @intDepLink
		,DEP_NAME	     = D3.FULL_NAME
		,SHOW_ALL		= @SHOW_ALL
		
		-- ""
		,G.COMMENT
		,FC.CHECK_NUMBER
		,CALC_TYPE = ISNULL(FC.CALC_TYPE,OPT.CALC_TYPE)
		,SNO = ISNULL(FC.SNO,CD.SNO)
		,CASHDESK_LINK  = CD.LINK
		,CASHDESK_CODE  = CD.CODE
		,CASHDESK_NAME  = CD.NAME
		,CASHIFT_LINK   = CASE WHEN c.copy IS NOT NULL AND (cs.STATE1=2 OR (SELECT DATEDIFF ( MINUTE , CS.BEGIN_TIME , GETDATE() ) /60) > 24) THEN NULL ELSE CS.LINK_UP END
		,CASHIFT_NUMBER = CASE WHEN c.copy IS NOT NULL AND (cs.STATE1=2 OR (SELECT DATEDIFF ( MINUTE , CS.BEGIN_TIME , GETDATE() ) /60) > 24) THEN NULL ELSE G_CS.NUMBER END
		,CASHIFT_DATE   = CASE WHEN c.copy IS NOT NULL AND (cs.STATE1=2 OR (SELECT DATEDIFF ( MINUTE , CS.BEGIN_TIME , GETDATE() ) /60) > 24) THEN NULL ELSE convert(varchar,cs.[BEGIN_TIME],104) +' '+ convert(varchar,cs.[BEGIN_TIME],108) END
		,EMPL_NAME		= e.FIO
		,EMPL_INN		= P.INN
		,COR_LINK       = COR.LINK
		,COR_CODE       = COR.CODE
		,COR_NAME       = dbo.departments_name_history(g.[date],cor.link)-- COR.NAME
		,DOG_LINK       = DOG.LINK
		,DOG_NAME       = dbo.obj_sname(DOG.OBJECT) + CASE WHEN ISNULL(DOG.NUMBER,'')!='' THEN ' ' + DOG.NUMBER ELSE '' END + CASE WHEN ISNULL(DOG.[DATE],'') != '' THEN '  ' + CONVERT(VARCHAR,DOG.[DATE],104) ELSE '' END
		,RETAIL = ISNULL(FC.RETAIL,1)
		,DOCUMENT_NUMBER = CASE WHEN c.copy IS NULL THEN F.FISCALDOCUMENTNUMBER ELSE NULL END
		,FISCAL_SIGN = CASE WHEN c.copy IS NULL THEN F.FISCALDOCUMENTSIGN ELSE NULL END
		
		,PAY_TYPE = ISNULL(FC.PAY_TYPE,OPT.PAY_TYPE)
		,PAY_FORM = COALESCE(FC.PAY_FORM,OPT.PAY_FORM,0)
		,[SUMMA]        = CASE WHEN c.copy IS NULL THEN g.SUMMA ELSE NULL END
		,FC.COM_PERC
		,FC.COM_SUMMA
		,CARD_LINK = CDS.LINK
		,CARD_NAME = CDS.NAME
		-- 
		,DIS_EDIT = CASE WHEN c.copy IS NULL AND F.FISCALDOCUMENTNUMBER IS NOT NULL THEN 1 ELSE 0 END
		
		,DOCBASE_LINK = GPD.DOCBASE_LINK
		,DOCBASE_NUM  = O.NUMBER
		,DOCBASE_NAME = O.DOC_NAME
		,ELECTRONICALLY = ISNULL(FC.ELECTRONICALLY,0)
		,EMAILORPHONE = CASE WHEN ISNULL(n.new,c.copy) IS NULL THEN FC.EMAILORPHONE ELSE ce.EMail END
		,PHONE = CASE WHEN ISNULL(n.new,c.copy) IS NULL THEN FC.PHONE ELSE cp.PHONE END
		,EXT_DEV_LINK = CD.EXT_DEV_LINK 
    FROM 
		dbo.G_PROV G
		RIGHT JOIN (SELECT NEW  = CONVERT(INT,CASE WHEN @nLink<0 THEN 1 ELSE NULL END)) N ON G.LINK=@nLink
		LEFT JOIN  (SELECT COPY = CONVERT(INT,CASE WHEN @cMode='copy' THEN 1 ELSE NULL END)) C ON NULL IS NULL   
		LEFT JOIN dbo.FR_CHECK FC ON FC.LINK_UP = G.LINK
		LEFT JOIN dbo.FR_CASHIFT CS ON CS.LINK_UP = case when @cMode='copy' or @nLink<0 then @iCASHIFT_LINK else FC.CASHIFT_LINK end
		LEFT JOIN dbo.FR_CASHDESK CD ON CD.LINK = CS.CASHDESK_LINK
		LEFT JOIN dbo.G_PROV G_CS ON G_CS.LINK = CS.LINK_UP
		LEFT JOIN dbo.FR_CHECK_OPT_AUTO OPT ON OPT.DEP_LINK = @intDepLink
		LEFT JOIN dbo.FINANSE_PAYS FP ON FP.LINK = G.LINK
		LEFT JOIN dbo.DEPARTMENTS COR ON COR.LINK = ISNULL(FP.PAYER_LINK,OPT.COR_LINK)
		LEFT JOIN dbo.G_PROV DOG ON DOG.LINK = FP.Link_Dogovor
		LEFT JOIN dbo.CARDS CDS ON CDS.LINK = FC.CARD_LINK
		LEFT JOIN dbo.G_PROV_DOCBASE GPD ON GPD.LINK_UP = G.LINK
		LEFT JOIN dbo.BD_OSNOV O ON O.LINK = GPD.DOCBASE_LINK
		LEFT JOIN dbo.FR_FISCALPARAMS F ON F.LINK_DOC = G.LINK
		LEFT JOIN dbo.V_EMPL e on E.LINK = cs.EMPL_LINK
		LEFT JOIN dbo.DEPARTMENTS P ON P.LINK = E.PERS_LINK
		left join contact cp on cp.dep_link = cor.link
		left join contact1 ce on ce.dep_link = cor.link
		LEFT JOIN dbo.DEPARTMENTS D3 ON D3.LINK = @intDepLink
		
	SELECT P.LINK INTO #PATTERN FROM dbo.PATTERN P 
		WHERE P.DEP_LINK = @intDepLink 
			AND P.IS_MAIN = 1 
			AND P.[OBJECT] = dbo.obj_id('FR_PRICELIST')
			AND ISNULL(P.DATEB,'19700101')<=@dDocDate AND ISNULL(P.DATEE,'20990101')> @dDocDate

	IF (@nLink < 0) AND EXISTS (SELECT * FROM #PATTERN)
	BEGIN
		
		SELECT
			CHECKED		= CONVERT(INT,0)
			,DEL		= CONVERT(INT,0)
			,UPD		= CONVERT(INT,1)
			,LINK			= -1*ROW_NUMBER()  OVER(ORDER BY PA.NOMEN_LINK)
			,LINK_UP		= @nLink
			,INV_TYPE		= PA.INV_TYPE
			,INV_LINK		= PA.NOMEN_LINK
			,INV_CODE		= NM.CODE
			,INV_NAME		= NM.NAME
			,PRICE			= PA.PRICE
			,QTY			= PA.QTY
			,SUMMA			= ISNULL(PA.PRICE,0)*ISNULL(PA.QTY,0)
			,STAVKA_NDS		= PA.STAVKA_NDS
			,NO_NDS			= PA.NO_NDS
			,SUMMA_NDS      = ISNULL(PA.PRICE,0)*ISNULL(PA.QTY,0) * (ISNULL(PA.STAVKA_NDS,0)/100)
			,SUMMA_ALL      = ISNULL(PA.PRICE,0)*ISNULL(PA.QTY,0) + ISNULL(PA.PRICE,0)*ISNULL(PA.QTY,0) *(ISNULL(PA.STAVKA_NDS,0)/100)
			-- 
			,SFIN_LINK		= FS.LINK
			,SFIN_CODE		= FS.CODE
			,KL_KBK_LINK	= KBK.LINK
			,KL_KBK_CODE	= KBK.CODE
			,EKR_LINK		= EKR.LINK
			,EKR_CODE		= EKR.CODE
			,KAU_LINK		= KAU.LINK
			,KAU_CODE		= KAU.CODE
			,DOP_CLASSIF_LINK = AP2.LINK
			,DOP_CLASSIF_CODE = AP2.CODE
			,LINK_UM		= NM.UM
			,NAME_UM		= M.SNAME
			,M_UNIT			= ISNULL(M.M_UNIT,0)
		FROM #PATTERN P
			INNER JOIN dbo.PAT_ANALIT PA ON PA.LINK_PATTERN = P.LINK
			INNER JOIN dbo.NOMENCLATURE NM ON NM.LINK = PA.NOMEN_LINK
			INNER JOIN dbo.FIN_SOURCE FS ON FS.LINK = PA.FIN_SOURCE
			INNER JOIN dbo.KL_KBK KBK ON KBK.LINK = PA.KBK
			INNER JOIN dbo.KOSGU EKR ON PA.EKR = EKR.LINK
			LEFT JOIN dbo.KAU KAU ON KAU.LINK = PA.KAU
			LEFT JOIN dbo.DOP_CLASSIF AP2 ON AP2.LINK = PA.AP2		
			LEFT JOIN dbo.MEASURE M ON M.LINK = NM.UM
	END
	ELSE
	BEGIN
		SELECT
			CHECKED		= CONVERT(INT,0)
			,DEL		= CONVERT(INT,0)
			,UPD		= COALESCE(n.new,c.copy,0)
			,OTR.ORDERS
			,LINK       = CASE WHEN ISNULL(n.new,c.copy) IS NULL THEN otr.LINK ELSE -1*(ISNULL(n.new,otr.LINK)) END
			,LINK_UP    = CASE WHEN c.copy IS NULL THEN otr.LINK_UP  ELSE -1*otr.LINK_UP END
			,INV_TYPE	= I.INV_TYPE
			,INV_LINK	= CASE WHEN I.INV_TYPE IN (1,5,6) THEN I.INV_LINK
							ELSE I.NOMEN_LINK	END
			,INV_CODE	= CASE WHEN I.INV_TYPE IN (1,5,6) THEN IC.CODE 
							ELSE NM.CODE	END
			,INV_NAME	= CASE WHEN I.INV_TYPE IN (1,5,6) THEN IC.NAME 
							ELSE NM.NAME	END
			,PRICE = CAST(MZ.PRICE AS NUMERIC(14,2))
			,QTY = CAST(MZ.QTY AS NUMERIC(14,4))
			,SUMMA = CAST(MZ.SUMMA AS NUMERIC(14,2))
			,STAVKA_NDS = CAST(STAVKA_NDS AS NUMERIC (2, 0))
			,MZ.SUMMA_NDS
			,MZ.NO_NDS
			,MZ.SUMMA_ALL
       
		   -- 
			,KAU_LINK = KU.LINK
			,KAU_CODE = KU.CODE
			,DOP_CLASSIF_LINK = DC.LINK
			,DOP_CLASSIF_CODE = DC.CODE
			,KL_KBK_LINK = K.LINK
			,KL_KBK_CODE = K.CODE
			,EKR_LINK = EKR.LINK
			,EKR_CODE = EKR.CODE
			,SFIN_LINK = FS.LINK
			,SFIN_CODE = FS.CODE
			,LINK_UM	= ISNULL(IC.LINK_UM,NM.LINK_UM)
			,NAME_UM	= M.SNAME
			,M_UNIT		= ISNULL(M.M_UNIT,0)
		FROM 
			--dbo.OUT_TABLE_MZ OTR 
			dbo.OUT_TABLE_ROW OTR
		LEFT JOIN dbo.OUT_TABLE_INV_TYPE I ON OTR.LINK = I.LINK_UP
		LEFT JOIN dbo.OUT_TABLE_MZ_SUMMA MZ ON MZ.LINK_ROW = OTR.LINK
		LEFT JOIN dbo.OUT_TABLE_ANALIT TA ON TA.LINK_ROW = OTR.LINK
			RIGHT JOIN (SELECT new  = CONVERT(INT,CASE WHEN @nLink<0 THEN 1 ELSE NULL END)) n ON otr.LINK_UP=@nLink
			LEFT JOIN  (SELECT copy = CONVERT(INT,CASE WHEN @cMode='copy' THEN 1 ELSE NULL END)) c ON NULL IS NULL 
			LEFT JOIN dbo.V_INVENTORY_CARD_S IC ON IC.LINK = I.INV_LINK
			LEFT JOIN dbo.BV_NOMENCLATURE_M NM ON NM.LINK = I.NOMEN_LINK
			LEFT JOIN dbo.KOSGU EKR ON EKR.LINK = TA.EKR
			lEFT JOIN dbo.FIN_SOURCE FS ON FS.LINK = TA.FIN_SOURCE
			LEFT JOIN dbo.KL_KBK k ON k.LINK = TA.KBK
			LEFT JOIN dbo.KAU ku ON ku.LINK = TA.KAU
			LEFT JOIN dbo.DOP_CLASSIF dc ON dc.LINK = TA.AP2
			LEFT JOIN dbo.MEASURE M ON M.LINK = ISNULL(IC.LINK_UM,NM.LINK_UM)
		WHERE 
			otr.LINK_UP = @nLink 
    END
	
	SELECT 
		CAST(0 as INT) AS UPD
		, D.LINK 
		, D.ROW_ID
		, D.TOTAL                                     --  
		, D.FISCALDOCUMENTNUMBER                      --    ()
		, D.FISCALDOCUMENTSIGN                        --   () 
		, D.FISCALDOCUMENTDATETIME                    --     ()
		, D.FISCALRECEIPTNUMBER                       --    
		, D.SHIFTNUMBER                               --   
		, D.FNNUMBER                                  --   
		, D.REGISTRATIONNUMBER                        -- 
		, D.RECEIPTSCOUNT                             --     
		, D.FNSURL                                    --   
		, D.FD_TYPE									  --  
		, D.LINK_DOC
		, D.DEP_LINK
	FROM dbo.FR_FISCALPARAMS D
	WHERE (D.LINK_DOC = @nLink
			AND @cMode != 'copy')

	--    
	exec dbo.X_GET_LINKED_DOCS @iLink = @nLink,@cMode = @cMode
GO


GRANT EXECUTE ON dbo.[FR_CHECK_S_E] TO PUBLIC

GO

/*  1.2
0 - piece - , ;
10 - gram  ;
11 - kilogram  ;
12 - ton  ;
20 - centimeter - ;
21 - decimeter  ;
22 - meter - ;
30 - squareCentimeter -  ;
31 - squareDecimeter -  ;
32 - squareMeter -  ;
40 - milliliter  ;
41 - liter  ;
42 - cubicMeter   ;
50 - kilowattHour   ;
51 - gkal  ;
70 - day   ();
71 - hour - ;
72 - minute  ;
73 - second  ;
80 - kilobyte  ;
81 - megabyte  ;
82 - gigabyte  ;
83 - terabyte  ;
255 - otherUnits -   ;	*/
--select *, 
update m
set 
	m_unit = case when name in ('','') then 0
					when name = '' then 10
					when name = '' then 11
					when name = '' then 12
					when name = '' then 20
					when name = '' then 21
					when name = '' then 22
					when name = '' then 40
					when name = '' then 41
					when name = '' then 70
					when name = '' then 70
					when name = '' then 71
					when name = '' then 72
					when name = '' then 73
					when name = '' then 80
					when name = '' then 81
					when name = '' then 82
					when name = '' then 83
					else null end
from dbo.measure m where m.m_unit is null
GO
